#include <stdio.h>
#include <stdlib.h>
#include "EndianIndependentFile.h"

int main()
{
	EndianIndependentFile TestFile("Test file", B_READ_WRITE, 10);
	if(TestFile.InitCheck() == B_NO_ERROR)
	{
		bool ReadCorrectly = true;
		uint32 Buffer32[4];
		if(TestFile.ReadNumber(Buffer32,sizeof(*Buffer32),2) != 2)
			ReadCorrectly = false;
		uint32 Counter;
		for(Counter = 0; Counter < 2; Counter++)
			if(Buffer32[Counter] != Counter)
				ReadCorrectly = false;
		printf("First read block %s read successfully\n",ReadCorrectly?"was":"WAS NOT");
		bool WrittenCorrectly = true;
		for(Counter = 2; Counter < 4; Counter++)
			if(TestFile.WriteNumber(&Counter,sizeof(Counter),1) != 1)
				WrittenCorrectly = false;
		if(WrittenCorrectly)
			WrittenCorrectly = (TestFile.FlushBuffer() == B_NO_ERROR);
		printf("Block write %s successful\n",WrittenCorrectly?"was":"WAS NOT");
		if(TestFile.Seek(0,SEEK_SET) != 0)
			printf("Seek FAILED\n");
		if(TestFile.ReadNumber(Buffer32,sizeof(*Buffer32),4) != 4)
			ReadCorrectly = false;
		for(Counter = 0; Counter < 4; Counter++)
			if(Buffer32[Counter] != Counter)
				ReadCorrectly = false;
		printf("First read/write block %s read successfully\n",ReadCorrectly?"was":"WAS NOT");
		uint16 Buffer16[4];
		for(Counter = 0; Counter < 4; Counter++)
			if(TestFile.ReadNumber(&Buffer16[Counter],sizeof(*Buffer16),1) != 1)
				ReadCorrectly = false;
		for(Counter = 0; Counter < 4; Counter++)
			if(Buffer16[Counter] != Counter)
				ReadCorrectly = false;
		printf("Second read block %s read successfully\n",ReadCorrectly?"was":"WAS NOT");
	}
	else
		printf("\"Test file\" COULD NOT be opened for read/write! Error = %08X\n"
			"Did you run DemoWrite first?\n",(int)TestFile.InitCheck());
}
